local function canCrouch(p)
	if not P_IsObjectOnGround(p.mo)
	or P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
		return false
	end
	return true
end

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smurf" return end
	
	if (p.cmd.buttons & BT_SPIN)
	and canCrouch(p)
		p.smurfcrouch = true
	elseif p.smurfcrouch ~= false
		p.smurfcrouch = false
	end
	
	if p.smurfcrouch
        p.mo.state = S_PLAY_GLIDE_LANDING
		p.pflags = $1|PF_STASIS
		if p.speed > 5*FU
		end
	end
end)

addHook("PlayerHeight", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smurf" return end
	
	if p.smurfcrouch return P_GetPlayerSpinHeight(p) end
end)

addHook("PlayerCanEnterSpinGaps", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smurf" return end
	
	if p.smurfcrouch return true end
end)

addHook("ThinkFrame", do
	for player in players.iterate
	    if not (player.mo and player.mo.skin == "smurf") then continue end    
		 
		 if (player.cmd.buttons & BT_CUSTOM1)
		     player.normalspeed = 40*FRACUNIT    
		 else
		     player.normalspeed = 26*FRACUNIT 
		end
    end
end)